

use<threads.scad>


/* [Parte a mostrar] */
// Elemento que desea mostrar en pantalla
Mostrar = "Cuerpo";    //[Cuerpo:Cuerpo donde se encajará la jeringa, Embolo:Émbolo roscado que empujará la jeringa]

/* [Parámetros de la jeringa] */
// Diámetro del cuerpo de la jeringa
Diametro = 31;

// Diámetro del empujador de pulgar
Diametro_E = 31;

// Parte ancha para el apoyo de los dedos
Ancho = 45;

// Parte estrecha para el apoyo de los dedos
Estrecho = 30;

// Largo desde el apoyo de los dedos hasta el extremo del émbolo
Largo = 123;

// Grosor del apoyo para los dedos
Grosor = 2;

/* [Hidden] */
Suavizado = 200;


module Pestana() {
translate([0,-Diametro/4,6]) cube([1.5,Diametro/2,17],center=true);
translate([-Diametro/4,-Diametro/2+0.75-5,6]) cube([Diametro/2,11.5,17],center=true);
}


module Cuerpo() {
difference() {
// Cuerpo
  translate([0,0,0]) cylinder(d=Ancho+6,h=Largo+35,$fn=Suavizado);
// Vaciado interior
    translate([0,0,15])cylinder(d=Diametro_E+0.5,h=Largo+40,$fn=Suavizado);
    translate([0,0,-1])cylinder(d=Diametro+0.4,h=17,$fn=Suavizado);
// Aperttura frontal
    translate([0,-Diametro_E/2-10.25,(Largo+35)/2+7.5-0.25-(10+Diametro_E/2)/2]) cube([Diametro_E+0.5,Diametro_E+20,Largo+35+0.5-15-10-Diametro_E/2],center=true);
    translate([0,-Diametro/2-10.25,0]) cube([Diametro+0.5,Diametro+20,Largo+35-15-10-Diametro/2],center=true);
    translate([0,-Diametro_E/2-10.25,(Largo+35+0.5-15-10-Diametro_E/2)/2+(Largo+35)/2+7.5-0.25-(10+Diametro_E/2)/2]) rotate([90,0,0]) cylinder(d=Diametro_E+0.5,h=Diametro+20,$fn=Suavizado,center=true);
// Encaje del apoyo para los dedos
    translate([0,0,15-0.5]) cylinder(d=Ancho+0.2,h=Grosor+0.4,$fn =Suavizado);
    translate([0,-Ancho/2,15-0.3+Grosor/2]) cube([Estrecho+0.2,Ancho+0.2,Grosor+0.4],center=true);
// Rosca
    translate([0,0,15+Grosor]) metric_thread(diameter=Diametro_E+2.5, pitch=2.5, length=Largo+18, internal=true, n_starts=1);
// Huecos para flexar las pestañas de encaje
    translate([Diametro/2+3,0,0]) Pestana();
    translate([-Diametro/2-3,0,0]) mirror([1,0,0]) Pestana();
}
// Pestañas de encaje
translate([Diametro/2,-Diametro/2+3.5,7.25]) cube([2,4,14.5],center=true);
translate([-Diametro/2,-Diametro/2+3.5,7.25]) cube([2,4,14.5],center=true);
}


module Embolo() {
// Rosca
translate([0,0,0]) metric_thread(diameter=Diametro_E+2, pitch=2.5, length=Largo+18, internal=false, n_starts=1);
// Asidero
minkowski() {
hull() {
translate([-35,0,-18]) cylinder(d=Diametro_E-10,h=16,$fn =Suavizado);
translate([0,0,-18]) cylinder(d=Diametro_E+4,h=16,$fn =Suavizado);
translate([35,0,-18]) cylinder(d=Diametro_E-10,h=16,$fn =Suavizado);
}
sphere(d=4,$fn=80);
}
}


if (Mostrar=="Cuerpo") {
Cuerpo();
}

if (Mostrar=="Embolo") {
translate([Diametro_E*2,0,19]) Embolo();
}